/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "./environments";
import * as core from "./core";
import { ApplePay } from "./api/resources/applePay/client/Client";
import { Applications } from "./api/resources/applications/client/Client";
import { ApplicationKeys } from "./api/resources/applicationKeys/client/Client";
import { ApplicationTemplates } from "./api/resources/applicationTemplates/client/Client";
import { NetworkTokens } from "./api/resources/networkTokens/client/Client";
import { Tokens } from "./api/resources/tokens/client/Client";
import { Enrichments } from "./api/resources/enrichments/client/Client";
import { Googlepay } from "./api/resources/googlepay/client/Client";
import { Logs } from "./api/resources/logs/client/Client";
import { Permissions } from "./api/resources/permissions/client/Client";
import { Proxies } from "./api/resources/proxies/client/Client";
import { Reactors } from "./api/resources/reactors/client/Client";
import { Roles } from "./api/resources/roles/client/Client";
import { Sessions } from "./api/resources/sessions/client/Client";
import { TokenIntents } from "./api/resources/tokenIntents/client/Client";
import { Webhooks } from "./api/resources/webhooks/client/Client";
import { Tenants } from "./api/resources/tenants/client/Client";
import { Threeds } from "./api/resources/threeds/client/Client";
export declare namespace BasisTheoryClient {
    interface Options {
        environment?: core.Supplier<environments.BasisTheoryEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey?: core.Supplier<string | undefined>;
        /** Override the BT-TRACE-ID header */
        correlationId?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the BT-TRACE-ID header */
        correlationId?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class BasisTheoryClient {
    protected readonly _options: BasisTheoryClient.Options;
    protected _applePay: ApplePay | undefined;
    protected _applications: Applications | undefined;
    protected _applicationKeys: ApplicationKeys | undefined;
    protected _applicationTemplates: ApplicationTemplates | undefined;
    protected _networkTokens: NetworkTokens | undefined;
    protected _tokens: Tokens | undefined;
    protected _enrichments: Enrichments | undefined;
    protected _googlepay: Googlepay | undefined;
    protected _logs: Logs | undefined;
    protected _permissions: Permissions | undefined;
    protected _proxies: Proxies | undefined;
    protected _reactors: Reactors | undefined;
    protected _roles: Roles | undefined;
    protected _sessions: Sessions | undefined;
    protected _tokenIntents: TokenIntents | undefined;
    protected _webhooks: Webhooks | undefined;
    protected _tenants: Tenants | undefined;
    protected _threeds: Threeds | undefined;
    constructor(_options?: BasisTheoryClient.Options);
    get applePay(): ApplePay;
    get applications(): Applications;
    get applicationKeys(): ApplicationKeys;
    get applicationTemplates(): ApplicationTemplates;
    get networkTokens(): NetworkTokens;
    get tokens(): Tokens;
    get enrichments(): Enrichments;
    get googlepay(): Googlepay;
    get logs(): Logs;
    get permissions(): Permissions;
    get proxies(): Proxies;
    get reactors(): Reactors;
    get roles(): Roles;
    get sessions(): Sessions;
    get tokenIntents(): TokenIntents;
    get webhooks(): Webhooks;
    get tenants(): Tenants;
    get threeds(): Threeds;
}
