/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import * as BasisTheory from "../../../index";
import { Domain } from "../resources/domain/client/Client";
import { Session } from "../resources/session/client/Client";
export declare namespace ApplePay {
    interface Options {
        environment?: core.Supplier<environments.BasisTheoryEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey?: core.Supplier<string | undefined>;
        /** Override the BT-TRACE-ID header */
        correlationId?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the BT-TRACE-ID header */
        correlationId?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class ApplePay {
    protected readonly _options: ApplePay.Options;
    protected _domain: Domain | undefined;
    protected _session: Session | undefined;
    constructor(_options?: ApplePay.Options);
    get domain(): Domain;
    get session(): Session;
    /**
     * @param {BasisTheory.ApplePayTokenizeRequest} request
     * @param {ApplePay.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.BadRequestError}
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.ForbiddenError}
     * @throws {@link BasisTheory.UnprocessableEntityError}
     *
     * @example
     *     await client.applePay.tokenize()
     */
    tokenize(request?: BasisTheory.ApplePayTokenizeRequest, requestOptions?: ApplePay.RequestOptions): Promise<BasisTheory.ApplePayTokenizeResponse>;
    protected _getCustomAuthorizationHeaders(): Promise<{
        "BT-API-KEY": string | undefined;
    }>;
}
