/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as BasisTheory from "../../../../../index";
export declare namespace Domain {
    interface Options {
        environment?: core.Supplier<environments.BasisTheoryEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey?: core.Supplier<string | undefined>;
        /** Override the BT-TRACE-ID header */
        correlationId?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the BT-TRACE-ID header */
        correlationId?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Domain {
    protected readonly _options: Domain.Options;
    constructor(_options?: Domain.Options);
    /**
     * @param {BasisTheory.applePay.ApplePayDomainDeregistrationRequest} request
     * @param {Domain.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.ForbiddenError}
     *
     * @example
     *     await client.applePay.domain.deregister({
     *         domain: "domain"
     *     })
     */
    deregister(request: BasisTheory.applePay.ApplePayDomainDeregistrationRequest, requestOptions?: Domain.RequestOptions): Promise<void>;
    /**
     * @param {Domain.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.UnauthorizedError}
     *
     * @example
     *     await client.applePay.domain.get()
     */
    get(requestOptions?: Domain.RequestOptions): Promise<BasisTheory.ApplePayDomainRegistrationResponse>;
    /**
     * @param {BasisTheory.applePay.ApplePayDomainRegistrationRequest} request
     * @param {Domain.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.BadRequestError}
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.ForbiddenError}
     * @throws {@link BasisTheory.UnprocessableEntityError}
     * @throws {@link BasisTheory.ServiceUnavailableError}
     *
     * @example
     *     await client.applePay.domain.register({
     *         domain: "domain"
     *     })
     */
    register(request: BasisTheory.applePay.ApplePayDomainRegistrationRequest, requestOptions?: Domain.RequestOptions): Promise<BasisTheory.ApplePayDomainRegistrationResponse>;
    /**
     * @param {BasisTheory.applePay.ApplePayDomainRegistrationListRequest} request
     * @param {Domain.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.BadRequestError}
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.ForbiddenError}
     * @throws {@link BasisTheory.UnprocessableEntityError}
     * @throws {@link BasisTheory.ServiceUnavailableError}
     *
     * @example
     *     await client.applePay.domain.registerAll()
     */
    registerAll(request?: BasisTheory.applePay.ApplePayDomainRegistrationListRequest, requestOptions?: Domain.RequestOptions): Promise<BasisTheory.ApplePayDomainRegistrationResponse>;
    protected _getCustomAuthorizationHeaders(): Promise<{
        "BT-API-KEY": string | undefined;
    }>;
}
