/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import * as BasisTheory from "../../../index";
export declare namespace ApplicationTemplates {
    interface Options {
        environment?: core.Supplier<environments.BasisTheoryEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey?: core.Supplier<string | undefined>;
        /** Override the BT-TRACE-ID header */
        correlationId?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the BT-TRACE-ID header */
        correlationId?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class ApplicationTemplates {
    protected readonly _options: ApplicationTemplates.Options;
    constructor(_options?: ApplicationTemplates.Options);
    /**
     * @param {ApplicationTemplates.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.NotFoundError}
     *
     * @example
     *     await client.applicationTemplates.list()
     */
    list(requestOptions?: ApplicationTemplates.RequestOptions): Promise<BasisTheory.ApplicationTemplate[]>;
    /**
     * @param {string} id
     * @param {ApplicationTemplates.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.NotFoundError}
     *
     * @example
     *     await client.applicationTemplates.get("id")
     */
    get(id: string, requestOptions?: ApplicationTemplates.RequestOptions): Promise<BasisTheory.ApplicationTemplate>;
    protected _getCustomAuthorizationHeaders(): Promise<{
        "BT-API-KEY": string | undefined;
    }>;
}
