/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as BasisTheory from "../../../../../index";
export declare namespace Invitations {
    interface Options {
        environment?: core.Supplier<environments.BasisTheoryEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey?: core.Supplier<string | undefined>;
        /** Override the BT-TRACE-ID header */
        correlationId?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the BT-TRACE-ID header */
        correlationId?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
    interface IdempotentRequestOptions extends RequestOptions {
        idempotencyKey?: string | undefined;
    }
}
export declare class Invitations {
    protected readonly _options: Invitations.Options;
    constructor(_options?: Invitations.Options);
    /**
     * @param {BasisTheory.tenants.InvitationsListRequest} request
     * @param {Invitations.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.ForbiddenError}
     *
     * @example
     *     await client.tenants.invitations.list()
     */
    list(request?: BasisTheory.tenants.InvitationsListRequest, requestOptions?: Invitations.RequestOptions): Promise<core.Page<BasisTheory.TenantInvitationResponse>>;
    /**
     * @param {BasisTheory.tenants.CreateTenantInvitationRequest} request
     * @param {Invitations.IdempotentRequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.BadRequestError}
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.ForbiddenError}
     *
     * @example
     *     await client.tenants.invitations.create({
     *         email: "email"
     *     })
     */
    create(request: BasisTheory.tenants.CreateTenantInvitationRequest, requestOptions?: Invitations.IdempotentRequestOptions): Promise<BasisTheory.TenantInvitationResponse>;
    /**
     * @param {string} invitationId
     * @param {Invitations.IdempotentRequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.BadRequestError}
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.ForbiddenError}
     *
     * @example
     *     await client.tenants.invitations.resend("invitationId")
     */
    resend(invitationId: string, requestOptions?: Invitations.IdempotentRequestOptions): Promise<BasisTheory.TenantInvitationResponse>;
    /**
     * @param {string} invitationId
     * @param {Invitations.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.ForbiddenError}
     * @throws {@link BasisTheory.NotFoundError}
     *
     * @example
     *     await client.tenants.invitations.get("invitationId")
     */
    get(invitationId: string, requestOptions?: Invitations.RequestOptions): Promise<BasisTheory.TenantInvitationResponse>;
    /**
     * @param {string} invitationId
     * @param {Invitations.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.ForbiddenError}
     * @throws {@link BasisTheory.NotFoundError}
     *
     * @example
     *     await client.tenants.invitations.delete("invitationId")
     */
    delete(invitationId: string, requestOptions?: Invitations.RequestOptions): Promise<void>;
    protected _getCustomAuthorizationHeaders(): Promise<{
        "BT-API-KEY": string | undefined;
    }>;
}
