/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as BasisTheory from "../../../../../index";
export declare namespace Members {
    interface Options {
        environment?: core.Supplier<environments.BasisTheoryEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey?: core.Supplier<string | undefined>;
        /** Override the BT-TRACE-ID header */
        correlationId?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the BT-TRACE-ID header */
        correlationId?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
    interface IdempotentRequestOptions extends RequestOptions {
        idempotencyKey?: string | undefined;
    }
}
export declare class Members {
    protected readonly _options: Members.Options;
    constructor(_options?: Members.Options);
    /**
     * @param {BasisTheory.tenants.MembersListRequest} request
     * @param {Members.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.ForbiddenError}
     *
     * @example
     *     await client.tenants.members.list()
     */
    list(request?: BasisTheory.tenants.MembersListRequest, requestOptions?: Members.RequestOptions): Promise<BasisTheory.TenantMemberResponsePaginatedList>;
    /**
     * @param {string} memberId
     * @param {BasisTheory.tenants.UpdateTenantMemberRequest} request
     * @param {Members.IdempotentRequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.ForbiddenError}
     * @throws {@link BasisTheory.NotFoundError}
     *
     * @example
     *     await client.tenants.members.update("memberId", {
     *         role: "role"
     *     })
     */
    update(memberId: string, request: BasisTheory.tenants.UpdateTenantMemberRequest, requestOptions?: Members.IdempotentRequestOptions): Promise<BasisTheory.TenantMemberResponse>;
    /**
     * @param {string} memberId
     * @param {Members.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.ForbiddenError}
     * @throws {@link BasisTheory.NotFoundError}
     * @throws {@link BasisTheory.UnprocessableEntityError}
     *
     * @example
     *     await client.tenants.members.delete("memberId")
     */
    delete(memberId: string, requestOptions?: Members.RequestOptions): Promise<void>;
    protected _getCustomAuthorizationHeaders(): Promise<{
        "BT-API-KEY": string | undefined;
    }>;
}
