/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import * as BasisTheory from "../../../index";
export declare namespace TokenIntents {
    interface Options {
        environment?: core.Supplier<environments.BasisTheoryEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey?: core.Supplier<string | undefined>;
        /** Override the BT-TRACE-ID header */
        correlationId?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the BT-TRACE-ID header */
        correlationId?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class TokenIntents {
    protected readonly _options: TokenIntents.Options;
    constructor(_options?: TokenIntents.Options);
    /**
     * @param {string} id
     * @param {TokenIntents.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.ForbiddenError}
     * @throws {@link BasisTheory.NotFoundError}
     *
     * @example
     *     await client.tokenIntents.get("id")
     */
    get(id: string, requestOptions?: TokenIntents.RequestOptions): Promise<BasisTheory.TokenIntent>;
    /**
     * @param {string} id
     * @param {TokenIntents.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.ForbiddenError}
     * @throws {@link BasisTheory.NotFoundError}
     *
     * @example
     *     await client.tokenIntents.delete("id")
     */
    delete(id: string, requestOptions?: TokenIntents.RequestOptions): Promise<void>;
    /**
     * @param {BasisTheory.CreateTokenIntentRequest} request
     * @param {TokenIntents.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link BasisTheory.BadRequestError}
     * @throws {@link BasisTheory.UnauthorizedError}
     * @throws {@link BasisTheory.ForbiddenError}
     *
     * @example
     *     await client.tokenIntents.create({
     *         type: "x",
     *         data: {
     *             "key": "value"
     *         }
     *     })
     */
    create(request: BasisTheory.CreateTokenIntentRequest, requestOptions?: TokenIntents.RequestOptions): Promise<BasisTheory.CreateTokenIntentResponse>;
    protected _getCustomAuthorizationHeaders(): Promise<{
        "BT-API-KEY": string | undefined;
    }>;
}
